<?php

include_once('init.php');

if(!isset($_SESSION['userid'])) {
	include('login.php');
	exit;
}

$error = '';
$notice = '';

if(isset($_REQUEST['add'])) {
	if(!$_REQUEST['login']) {
		$error = 'login cannot be empty';
	} else {
		$stmt = new Statement("INSERT INTO {$GLOBALS['fc_config']['db']['pref']}users (login, password, roles) VALUES (?, ?, ?)");
		$_REQUEST['id'] = $stmt->process($_REQUEST['login'], $_REQUEST['password'], $_REQUEST['roles']);
		$notice = 'user added';
	}
} else if(isset($_REQUEST['set'])) {
	if(!$_REQUEST['login']) {
		$error = 'login cannot be empty';
	} else if(!$_REQUEST['id']) {
		$error = 'wrong user id';
	} else {
		$stmt = new Statement("UPDATE {$GLOBALS['fc_config']['db']['pref']}users SET login=?, password=?, roles=? WHERE id=?");
		$stmt->process($_REQUEST['login'], $_REQUEST['password'], $_REQUEST['roles'], $_REQUEST['id']);
		$notice = 'user updated';
	}
} else if(isset($_REQUEST['del'])) {
	if(!$_REQUEST['id']) {
		$error = 'wrong user id';
	} else {
		$stmt = new Statement("DELETE FROM {$GLOBALS['fc_config']['db']['pref']}users WHERE id=?");
		$stmt->process($_REQUEST['id']);
		$notice = 'user removed';
		$_REQUEST['id'] = null;
	}
}

$roles = array(
	ROLE_USER => 'user',
	ROLE_ADMIN => 'admin',
	ROLE_SPY => 'spy',
	ROLE_CUSTOMER => 'customer'
);

if(isset($_REQUEST['id'])) {
	$stmt = new Statement("SELECT * FROM {$GLOBALS['fc_config']['db']['pref']}users WHERE id=?");
	$rs = $stmt->process($_REQUEST['id']);
	$_REQUEST = $rs->next();
} else {
	$_REQUEST['id'] = 0;
	$_REQUEST['login'] = '';
	$_REQUEST['password'] = '';
	$_REQUEST['roles'] = ROLE_USER;
}

//Assign Smarty variables and load the admin template
$smarty->assign('error',$error);
$smarty->assign('notice',$notice);
$smarty->assign('roles',$roles);
$smarty->assign('_REQUEST',$_REQUEST);
$smarty->display('user.tpl');

?>
