<?php
	$GLOBALS['curruserid'] = 0;

	class ChatServer {
		//User handlers
		function isLoggedIn( $args = array() ) {
			if($GLOBALS['curruserid'] == SPY_USERID)
			{
				return SPY_USERID;
			} 
			else if( isset($args['is_bot']) && $args['is_bot'] != null  && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				return $myBot->getBotId( $args['login'] ); 	
			}
			else
			{
				return $GLOBALS['fc_config']['cms']->isLoggedIn();
			}
		}

		function login($login, $password, $args = array()) {
			if($password == $GLOBALS['fc_config']['spyPassword'])
			{
				$GLOBALS['curruserid'] = SPY_USERID;
			} 
			else if( isset($args['is_bot']) && $args['is_bot'] != null && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				$GLOBALS['curruserid'] = $myBot->getBotId( $login );
			}
			else
			{
				$GLOBALS['curruserid'] = $GLOBALS['fc_config']['cms']->login($login, $password);
			}

			return $GLOBALS['curruserid'];
		}

		function logout() {
			$GLOBALS['curruserid'] = 0;
			$GLOBALS['fc_config']['cms']->logout();
		}

		function getUser( $userid ) {
			if( $userid == SPY_USERID )
			{
				return array('id' => SPY_USERID, 'login' => 'spy', 'roles' => ROLE_SPY);
			} 
			else if( $userid < SPY_USERID && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				return( $myBot->getUser($userid) );
			}
			else
			{
				return $GLOBALS['fc_config']['cms']->getUser($userid);
			}
		}
		
		function getUsers( ) {
			return $GLOBALS['fc_config']['cms']->getUsers();
		}
		
		//temporary function
		function getGender($userid) 
		{
			if($userid <= SPY_USERID) 
			{
				return '';
			} else 
			{
				$ret = '';
				if( method_exists($GLOBALS['fc_config']['cms'], 'getGender') )
				{
					$ret = $GLOBALS['fc_config']['cms']->getGender($userid);
				}
				else
				{
					$ret = 'U';//Note: if metod not exists default user is undefined
				}
				
				$ret = (trim($ret) == '') ? 'U' : trim($ret);
				
				return $ret;
				
			}
		}

		function getUserProfile($userid) {
			return $GLOBALS['fc_config']['cms']->getUserProfile($userid);
		}

		function userInRole($userid, $role) {
			if($userid == SPY_USERID)
			{
				return (ROLE_SPY & $role) != 0;
			}
			else if( $userid < SPY_USERID && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				$user = $myBot->getUser($userid);
				return( $role == $user['role'] );
			} 
			else
			{
				return $GLOBALS['fc_config']['cms']->userInRole($userid, $role);
			}
		}

		//Connecton handlers
		function &getConnection($req = array()) {
			if(!isset($req['id']) || !$req['id']) $req['id'] = null;

			return new Connection($req['id'], array( 'is_bot' => $req['bot_ip'], 'login' => $req['login']) );
		}
		
		function addUser($login, $password, $roles){
			return $GLOBALS['fc_config']['cms']->addUser($login, $password, $roles);
		}
		
		function deleteUser($login){
			$GLOBALS['fc_config']['cms']->deleteUser($login);
		}
		
		function writeToFile($arr, $path)
		{
			$data = serialize($arr);
											
			$file = fopen( $path, "wb" );
			$res = fwrite($file, $data);
			
			fflush($file);
			fclose($file);
		}
		
		function readFromFile($path)
		{
			$file = fopen( $path, "rb" );
			$data = fread( $file, filesize( $path ) ) ;
			fclose($file);
			
			return (unserialize($data));
		}
		
		function purgeExpired() {
			$file_path = $GLOBALS['fc_config']['appdata_path'];	
			$arr = array();
			
			if( file_exists( $file_path ) && filesize( $file_path ) > 0 )
			{
				$arr = ChatServer::readFromFile($file_path);
			}
			else 
			{
				$arr['time'] = time();
				ChatServer::writeToFile($arr, $file_path);
			}
			
			if((time() - $arr['time']) > $GLOBALS['fc_config']['msgRequestInterval'])
			{
				$arr['time'] = time() + 3600;
				ChatServer::writeToFile($arr, $file_path);
				
				$bot_ip = $GLOBALS['fc_config']['bot_ip'];
				if($GLOBALS['fc_config']['enableBots'] == false) 
				{ 
					$stmt = new Statement("DELETE FROM {$GLOBALS['fc_config']['db']['pref']}connections WHERE ip = ?");
					$stmt->process($bot_ip);
				}
				else
				{
					$stmt = new Statement("UPDATE {$GLOBALS['fc_config']['db']['pref']}connections SET updated=NOW() WHERE userid IS NOT NULL AND ip=?");
					$stmt->process($bot_ip);
					
					$myBot = new Bot();
					$myBot->processOptions();
				}
							
				//Do all we need
				//Close expired connection
				$stmt = new Statement("DELETE FROM {$GLOBALS['fc_config']['db']['pref']}connections WHERE updated < DATE_SUB(NOW(),INTERVAL ? SECOND)");
				$stmt->process($GLOBALS['fc_config']['autocloseAfter']);

				//Logout expired users
				$stmt = new Statement("SELECT id FROM {$GLOBALS['fc_config']['db']['pref']}connections WHERE userid IS NOT NULL AND updated < DATE_SUB(NOW(),INTERVAL ? SECOND) AND ip <> ?");
				if($rs = $stmt->process($GLOBALS['fc_config']['autologoutAfter'], $bot_ip)) {
					while($rec = $rs->next()) {
						$conn = new Connection($rec['id']);
						$conn->doLogout('expiredlogin');
					}
				}
	
				//Remove expired rooms
				$stmt = new Statement("SELECT id FROM {$GLOBALS['fc_config']['db']['pref']}rooms WHERE ispermanent IS NULL AND updated < DATE_SUB(NOW(),INTERVAL ? SECOND)");
				$rmst = new Statement("DELETE FROM {$GLOBALS['fc_config']['db']['pref']}rooms WHERE ispermanent IS NULL AND id=?");
				if($rs = $stmt->process($GLOBALS['fc_config']['autoremoveAfter'])) {
					$messageQueue = new MessageQueue();
					while($room = $rs->next()) {
						$messageQueue->addMessage(new Message('rmr', null, $room['id']));
						$rmst->process($room['id']);
					}
				}
	
				//Remove expired messages
				$rmst = new Statement("DELETE FROM {$GLOBALS['fc_config']['db']['pref']}messages WHERE created < DATE_SUB(NOW(),INTERVAL ? SECOND)");
				$rmst->process($GLOBALS['fc_config']['msgRemoveAfter']);

				//Remove expired bans
				$rmst = new Statement("DELETE FROM {$GLOBALS['fc_config']['db']['pref']}bans WHERE created < DATE_SUB(NOW(),INTERVAL ? SECOND)");
				$rmst->process($GLOBALS['fc_config']['autounbanAfter']);
						
				//write time to file
				$arr['time'] = time();
				ChatServer::writeToFile($arr, $file_path);
			}
		}

	}
?>
