<?php
	class Connection {
		var $id = null;
		var $userid = null;
		var $roomid = null;
		var $color = null;
		var $state = 1;
		var $start = 0;
		var $lang = 'en';
		var $ip = '';
		var $tzoffset = 0;
		
		var $messageQueue;

		function Connection($id = null, $args = array()) {
			$this->messageQueue = new MessageQueue();

			if($id) {
				$stmt = new Statement("SELECT * FROM {$GLOBALS['fc_config']['db']['pref']}connections WHERE id=?");
				$rs = $stmt->process($id);
				if($rec = $rs->next()) {
					$this->id = $rec['id'];
					$this->userid = $rec['userid'];
					$this->roomid = $rec['roomid'];
					$this->color = $rec['color'];
					$this->state = $rec['state'];
					$this->start = $rec['start'];
					$this->lang = $rec['lang'];
					$this->ip = $rec['ip'];
					$this->tzoffset = $rec['tzoffset'];

					//Touch connection
					$stmt = new Statement("UPDATE {$GLOBALS['fc_config']['db']['pref']}connections SET updated=NOW() WHERE id=?");
					$stmt->process($this->id);

					//Touch room
// next line fix for default room touch 
					if($this->roomid == $GLOBALS['fc_config']['defaultRoom']) return;
					$stmt = new Statement("UPDATE {$GLOBALS['fc_config']['db']['pref']}rooms SET updated=NOW() WHERE id=?");
					$stmt->process($this->roomid);

					return;
				}
			}

			$this->id = md5(uniqid(rand(), true));
			$this->userid = ChatServer::isLoggedIn( $args );
			$this->roomid = $this->getAvailableRoom($GLOBALS['fc_config']['defaultRoom']);
			$color = $GLOBALS['fc_config']['themes'][$GLOBALS['fc_config']['defaultTheme']]['recommendedUserColor'];
			if($color == null) $color = 0xFFFFFF;
			$this->color = $color;
			$this->state = 1;
			$this->lang = $GLOBALS['fc_config']['defaultLanguage'];
			$this->ip = ($args['is_bot'] == null)? $_SERVER['REMOTE_ADDR'] : $args['is_bot']; 
						
			if($this->userid > 0 && $this->userid != null) {
				$this->start = $this->sendLoginInfo();
			} else {
				$this->start = $this->sendBack(new Message('lout', null, null, 'login'));
			}
			
			if($bot_ip != null && $this->start <= 1) return;
			$stmt = new Statement("INSERT INTO {$GLOBALS['fc_config']['db']['pref']}connections (id, updated, created, userid, roomid, color, state, start, lang, ip) VALUES (?, NOW(), NOW(), ?, ?, ?, ?, ?, ?, ?)");
			$stmt->process($this->id, $this->userid, $this->roomid, $this->color, $this->state, $this->start, $this->lang, $this->ip);
		}
		
		function getAvailableRoom($roomId)
		{
			$stmt = new Statement("SELECT id FROM {$GLOBALS['fc_config']['db']['pref']}rooms");
			$rs = $stmt->process();
			
			$retval = 0;
			while($rec = $rs->next())
			{
				if($retval == 0) $retval = $rec['id'];
				if($rec['id'] == $roomId) 
				{
					$retval = $roomId;
					break;
				}
			}
		
			return ($retval);
		}
		
		function save() {
			$stmt = new Statement("UPDATE {$GLOBALS['fc_config']['db']['pref']}connections SET updated=NOW(), userid=?, roomid=?, color=?, state=?, start=?, lang=?, tzoffset=? WHERE id=?");
			$stmt->process($this->userid, $this->roomid, $this->color, $this->state, $this->start, $this->lang, $this->tzoffset, $this->id);
		}

		function send($message) {
			//Spy can send messages back to him self only
			if(ChatServer::userInRole($this->userid, ROLE_SPY)) {
				$message->toconnid = $this->id;
				$message->touserid = null;
				$message->toroomid = null;
			}
			
			return $this->messageQueue->addMessage($message);
		}

		function sendBack($message) {
			$message->toconnid = $this->id;
			return $this->send($message);
		}

		function sendToUser($userid, $message) {
			$stmt = new Statement("SELECT * FROM {$GLOBALS['fc_config']['db']['pref']}ignors WHERE userid=? AND ignoreduserid=?");
			if(
				($rs = $stmt->process($userid, $this->userid)) && $rs->hasNext() && 
				 $message->command != 'ignu' && $message->command != 'nignu'
			) 
			{
				$this->sendBack(new Message('error', $userid, 0, 'ignored'));
			} else {
				switch($message->command) {
					case 'nignu': 
					case 'ignu': 
					case 'msg': 
						$message->toconnid = $this->id;
						break;
				}
				
				/*
				$stmt = new Statement("SELECT id FROM {$GLOBALS['fc_config']['db']['pref']}users WHERE roles=?");
				if(($rs = $stmt->process(ROLE_ADMIN)))
				{
					while($rs->hasNext())
					{
						$i = $rs->next();
						$message->touserid = $i['id'];
						if($message->touserid != $this->userid && $message->touserid != $userid ) $this->send($message);
					}
				}
				*/
				 
				$message->touserid = $userid;
				return $this->send($message);
			}
		}

		function sendToAll($message) {
			$message->toconnid = null;
			$message->touserid = null;
			$message->toroomid = null;
			return $this->send($message);
		}

		function sendToRoom($roomid, $message) {
			$message->toroomid = $roomid;
			return $this->send($message);
		}		

		function process($req) {
			//Set default values for missed request params
			if(!isset($req['c'])) $req['c']   = 'msgl'; //command
			if(!isset($req['u'])) $req['u']   = null;   //userId or UserName
			if(!isset($req['r'])) $req['r']   = null;   //roomId
			if(!isset($req['b'])) $req['b']   = 0;      //backtime
			if(!isset($req['t'])) $req['t']   = '';     //text
			if(!isset($req['l'])) $req['l']   = null;   //language
			if(!isset($req['p'])) $req['p']   = 0;      //is public room
			if(!isset($req['lg'])) $req['lg'] = '';     //login
			if(!isset($req['ps'])) $req['ps'] = '';     //password
			if(!isset($req['n'])) $req['n']   = 0;      //???
			if(!isset($req['a'])) $req['a']   = '';     // additional arguments
			if(!isset($req['s'])) $req['s']   = 0;      //???
			if(!isset($req['tz'])) $req['tz'] = 0;      //timezone 
			
			if(get_magic_quotes_gpc()) {
				foreach($req as $k => $v) $req[$k] = stripslashes($v);
			}

			if($req['c'] == 'lin') {
				//Try to login
				$this->doLogin($req['lg'], $req['ps'], $req['l'], $req['tz'], $req['r'], $req['bot_ip']);
			} else if($req['c'] == 'tzset') {
				$this->doTimeZoneSet($req['tz']);
			} else if($this->userid) {
				//Process request
				switch($req['c']) {
					case 'msgl'  : $this->doLoadMessages(); break;
					case 'lout'  : $this->doLogout(); break;
					case 'msg'   : $this->doSendMessageTo($req['u'], $req['r'], $req['t'], $req['a']); break;
					case 'mvu'   : $this->doMoveTo($req['r']); break;
					case 'adr'   : $this->doCreateRoom($req['l'], $req['p']); break;
					case 'invu'  : $this->doInviteUserTo($req['u'], $req['r'], $req['t']); break;
					case 'inva'  : $this->doAcceptInvitationTo($req['u'], $req['r'], $req['t']); break;
					case 'invd'  : $this->doDeclineInvitationTo($req['u'], $req['r'], $req['t']); break;
					case 'ignu'  : $this->doIgnoreUser($req['u'], $req['t']); break;
					case 'nignu' : $this->doUnignoreUser($req['u'], $req['t']); break;
					case 'banu'  : $this->doBanUser($req['u'], $req['b'], $req['r'], $req['t']); break;
					case 'nbanu' : $this->doUnbanUser($req['u'], $req['t']); break;
					case 'sst'   : $this->doSetState($req['t']); break;
					case 'scl'   : $this->doSetColor($req['t']); break;
					case 'usrp'  : $this->doRequestUserProfileText($req['u']); break;
					case 'help'  : $this->doRequestHelpText(); break;
					case 'ring'  : $this->doRing(); break;
					case 'back'  : $this->doBack($req['n']); break;
					case 'backt' : $this->doBacktime($req['n']); break;
					case 'glan'  : $this->doGetLanguage($req['l'], true, $req['s']); break;
					case 'alrt'  : $this->doAlert($req['u'], $req['t']); break;
					case 'ralrt' : $this->doRoomAlert($req['r'], $req['t']); break;
					case 'calrt' : $this->doChatAlert($req['t']); break;
					case 'gag'   : $this->doGag($req['u'], $req['t']); break;
					case 'ngag'  : $this->doUnGag($req['u'], $req['t']); break;
					case 'cfrm'  : $this->doConfirm($req['u'], $req['t'], $req['a']); break; 
					case 'mavt'  : 
					case 'ravt'  : $this->doSendAvatar($req['c'], $req['a'], $req['u']); break;
					case 'srtbt' : $this->doStartBot($req['lg'], $req['r']); break;
					case 'klbt'  : $this->doKillBot($req['lg']); break;
					case 'adbt'  : $this->doAddBot($req['lg'], $req['a']); break;
					case 'rmbt'  : $this->doRemoveBot($req['lg']); break;
					case 'tchbt' : $this->doTeachBot($req['lg'], $req['a']); break;
					case 'utbt'  : $this->doUnTeachBot($req['lg'], $req['a']); break;
					case 'swbt'  : $this->doShowBots(); break;
					case 'sgen'  : $this->doSetGender($req['u'], $req['t']); break;
					default: addError("Unhandled request: {$req['c']}"); break;
				}
			}

			//Send back actual messages
			$start = max($this->start, $req['b']);
			return $this->messageQueue->getMessages($this->id, $this->userid, $this->roomid, $start);
		}

		function doTimeZoneSet($tzoffset) {
			$this->tzoffset = $tzoffset;
			$this->save();
		}

		function doLoadMessages() {
		}

		function doLogin($login, $password, $lang, $tzoffset, $roomid = null, $bot_id = null) {
			include_once(INC_DIR . 'classes/doLogin.php');
		}
		
		function doGetLanguage($lang, $save=false, $save_only=0) {
			return (include_once(INC_DIR . 'classes/doGetLanguage.php'));
		}
		
		function sendLoginInfo() {
			return (include_once(INC_DIR . 'classes/sendLoginInfo.php'));
		}

		function doLogout($msg = null) {
			include_once(INC_DIR . 'classes/doLogout.php');
		}

		function doSendMessageTo($touserid, $toroomid, $txt, $args) {
			$type = ($args == 'isUrgent')?'msgu':'msg';

// start query, msg, whois, whowas, who, unignore, showignores, showbans, rooms, reban and names fix

			$txt = trim($txt, ' ');
			if(strpos($txt, ' ')) $irc_len = strpos($txt, ' '); else $irc_len = strlen($txt);
			$irc_cmd = strtolower(substr($txt, 0, $irc_len));

 			$role_admin = ChatServer::userInRole($this->userid, ROLE_ADMIN);

			if(substr($irc_cmd, 0, 1) == '/' && !strstr($GLOBALS['fc_config']['disabledIRC'], substr($irc_cmd, 1))) {

				if((include_once(INC_DIR . 'classes/commands.php')) == 'ok') return;
			}

// end query, msg, whois, whowas, who, unignore, showignores and names fix



			if($touserid) {
				$this->sendToUser($touserid, new Message($type, $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
				//$this->sendToUser($touserid, new Message($type, $this->userid, null, $txt, $this->color));
			} else {
				if(!$role_admin) $toroomid = $this->roomid;

				$this->sendToRoom($toroomid?$toroomid:null, new Message($type, $this->userid, $toroomid, $txt, $this->color));
			}
		}

		function doMoveTo($toroomid, $msg = null) {
			include_once(INC_DIR . 'classes/doMoveTo.php');
		}

		function doCreateRoom($label, $isPublic) {
			return (include_once(INC_DIR . 'classes/doCreateRoom.php'));
		}

		function doInviteUserTo($invitedUserID, $toRoomID, $txt) {
			include_once(INC_DIR . 'classes/doInviteUserTo.php');
		}

		function doAcceptInvitationTo($invitedByUserID, $toRoomID, $txt) {
			$this->sendToUser($invitedByUserID, new Message('inva', $this->userid, $toRoomID, $txt));
		}
	
		function doDeclineInvitationTo($invitedByUserID, $toRoomID, $txt) {
			include_once(INC_DIR . 'classes/doDeclineInvitationTo.php');
		}

		function doIgnoreUser($ignoredUserID, $txt) {
			include_once(INC_DIR . 'classes/doIgnoreUser.php');
		}

		function doUnignoreUser($ignoredUserID, $txt) {
			include_once(INC_DIR . 'classes/doUnignoreUser.php');
		}

		function doBanUser($bannedUserID, $banType, $fromRoomID, $txt) {
			include_once(INC_DIR . 'classes/doBanUser.php');
		}

		function doUnbanUser($bannedUserID, $txt) {
			include_once(INC_DIR . 'classes/doUnbanUser.php');
		}
		
		function doAlert($userID, $txt) {
			include_once(INC_DIR . 'classes/doAlert.php');
		}

		function doRoomAlert($roomID, $txt) {
			include_once(INC_DIR . 'classes/doRoomAlert.php');
		}
		
		function doChatAlert($txt) {
			include_once(INC_DIR . 'classes/doChatAlert.php');
		}
		
		function doGag($userID, $min) {
			include_once(INC_DIR . 'classes/doGag.php');
		}
		
		function doUnGag($userID, $txt){
			include_once(INC_DIR . 'classes/doUnGag.php');
		}
		
		function doConfirm($userID, $data, $args){
			include_once(INC_DIR . 'classes/doConfirm.php');
		}
		
		function doSendAvatar($type, $args, $userID){
			if($userID == 0)
				$this->sendToAll(new Message($type, $this->userid, null, $args));		
			else
				$this->sendToUser($userID, new Message($type, $this->userid, null, $args));	
		}

		function doSetState($state) {
			$this->state = $state;
			$this->sendToAll(new Message('ustc', $this->userid, null, $this->state));

			$this->save();
		}

		function doSetColor($color) {
			$this->color = $color;
			$this->sendToAll(new Message('uclc', $this->userid, null, $this->color));

			$this->save();
		}

		function doRequestUserProfileText($userid) {
			$this->sendBack(new Message('usrp', $userid, null, ChatServer::getUserProfile($userid, $this->userid)));
		}

		function doRequestHelpText() {
			$this->sendBack(new Message('help', null, null, "<b>help</b> text"));
		}

		function doRing() {
			include_once(INC_DIR . 'classes/doRing.php');
		}

		function doBack($numb) {
			include_once(INC_DIR . 'classes/doBack.php');
		}

		function doBacktime($numb) {
			include_once(INC_DIR . 'classes/doBacktime.php');
		}
		
		function doStartBot($login, $roomId) {
			if(ChatServer::userInRole($this->userid, ROLE_ADMIN) && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				if(!$myBot->login($login, $roomId, true))
				{
					$txt = "<b>Bot '$login' does not exist.</b>";
					$this->sendToUser(null, new Message('msg', $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
				}
			}
		}
		
		function doKillBot($userName){
			if(ChatServer::userInRole($this->userid, ROLE_ADMIN) && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				$myBot->logout($userName);
			}
		}
		
		function doAddBot($login, $bot){
			if(ChatServer::userInRole($this->userid, ROLE_ADMIN) && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				$user_id = $myBot->getNextId();
				
				if($myBot->connectUser2Bot($user_id, $login, $bot))
				{
					$txt = "<b>Bot '$login' added succesfully.</b>";
					$this->sendToUser(null, new Message('msg', $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
				}
				else
				{
					$txt = "<b>Bot '$login' is not added.</b>";
					$this->sendToUser(null, new Message('msg', $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
				}
			}
		}
		
		function doRemoveBot($userName){
			if(ChatServer::userInRole($this->userid, ROLE_ADMIN) && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				$userId = $myBot->logout($userName);
				if($userId != null)
				{
					$myBot->disconnectUser2Bot($userId);
										
					$txt = "<b>Bot '$userName' removed succesfully.</b>";
					$this->sendToUser(null, new Message('msg', $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
				}
				else
				{
					$txt = "<b>Bot '$userName' is not removed or not exists.</b>";
					$this->sendToUser(null, new Message('msg', $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
				}
			}
		}
		
		function doTeachBot($userName, $args){
			if(ChatServer::userInRole($this->userid, ROLE_ADMIN) && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				if($myBot->teach($userName, $args))
				{
					$txt = "<b>Bot '$userName' is teached succesfully.</b> $args";
					$this->sendToUser(null, new Message('msg', $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
				}
				else
				{
					$txt = "<b>Bot '$userName' is not teached.</b>";
					$this->sendToUser(null, new Message('msg', $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
				}
			}
		}
		
		function doUnTeachBot($userName, $args){
			if(ChatServer::userInRole($this->userid, ROLE_ADMIN) && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				if($myBot->unteach($userName, $args))
				{
					$txt = "<b>Bot '$userName' is unteached succesfully.</b> $args";
					$this->sendToUser(null, new Message('msg', $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
				}
				else
				{
					$txt = "<b>Bot '$userName' is not unteached.</b>";
					$this->sendToUser(null, new Message('msg', $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
				}
			}
		}
				
		function doShowBots(){
			if(ChatServer::userInRole($this->userid, ROLE_ADMIN) && $GLOBALS['fc_config']['enableBots'])
			{
				$myBot = new Bot();
				$txt = $myBot->showBots();
				$this->sendToUser(null, new Message('msg', $this->userid, $GLOBALS['fc_config']['liveSupportMode']?$this->roomid:null, $txt, $this->color));
			}
		}
		
		function doSetGender($userID, $gender){
				$this->sendToUser($userID, new Message('sgen', $this->userid, null, $gender));	
		}
	}
?>
