<?php
	//The StatelessCMS implementation ignors user passwords and assign admin role for thouse users who provided admin pasword during login.

	class StatelessCMS {
		var $userid = null;

		var $loginStmt;
		var $getUserStmt;
		var $addUserStmt;
		var $setUserStmt;
		var $getUsersStmt;

		function StatelessCMS() {
			$this->loginStmt = new Statement("SELECT * FROM {$GLOBALS['fc_config']['db']['pref']}users WHERE login=?");
			$this->getUserStmt = new Statement("SELECT * FROM {$GLOBALS['fc_config']['db']['pref']}users WHERE id=?");
			$this->addUserStmt = new Statement("INSERT INTO {$GLOBALS['fc_config']['db']['pref']}users (login, roles) VALUES(?, ?)");
			$this->setUserStmt = new Statement("UPDATE {$GLOBALS['fc_config']['db']['pref']}users SET roles=? WHERE id=?");
			$this->getUsersStmt = new Statement("SELECT * FROM {$GLOBALS['fc_config']['db']['pref']}users ORDER BY login");
			$this->delUserStmt = new Statement("DELETE FROM {$GLOBALS['fc_config']['db']['pref']}users WHERE login=?");
		}

		function isLoggedIn() {
			return $this->userid;
		}

		function login($login, $password) {
			$this->userid = null;

			$roles = $GLOBALS['fc_config']['liveSupportMode']?ROLE_CUSTOMER:ROLE_USER;
			if($password && ($password == $GLOBALS['fc_config']['adminPassword'])) {
				$roles = ROLE_ADMIN;
			}
			
			if($login) {
				if(($rs = $this->loginStmt->process($login)) && ($rec = $rs->next())) {
					$this->userid = $rec['id'];
					$this->setUserStmt->process($roles, $this->userid);
				} else {
					$this->userid = $this->addUserStmt->process($login, $roles);
				}
			}

			return $this->userid;
		}

		function logout(){
			$this->user = null;
		}
	
		function getUser($userid) {
			if($userid) {
				$rs = $this->getUserStmt->process($userid);
				return $rs->next();
			} else {
				return null;
			}
		}

		function getUsers() {
			return 	$this->getUsersStmt->process();
		}

		function getUserProfile($userid) {
			return null;
		}

		function userInRole($userid, $role) {
			if($user = $this->getUser($userid)) {
				return ($user['roles'] & $role) != 0;
			}
			return false;
		}
		
		function getGender($user) {
     	   // 'M' for Male, 'F' for Female, NULL for undefined
        	return null;        
	    }
		
		function addUser($login, $password, $roles){
			$user = $this->loginStmt->process($login);
			if(($rec = $user->next()) != null) return $rec['id'];
			return $this->addUserStmt->process($login, $roles);
		}
		
		function deleteUser($login){
			$this->delUserStmt->process($login);
		}
	}

	$GLOBALS['fc_config']['cms'] = new StatelessCMS();
?>