<?php
	error_reporting(0);

	include_once('inc/common.php');

	header("Pragma: public");
	header("Expires: 0");
	header("Content-type: text/xml");
	//header('Content-type: text/plain');

	$cmsclass = strtolower(get_class($GLOBALS['fc_config']['cms']));
	$hasProfile = ($cmsclass != 'statelesscms');

?>
<settings 
	debug="<?=$GLOBALS['fc_config']['debug']?>"
	version="<?=$GLOBALS['fc_config']['version']?>" 
	enableSockets="<?=$GLOBALS['fc_config']['enableSockets']?>"
	liveSupportMode="<?=$GLOBALS['fc_config']['liveSupportMode']?>"
	hideSelfPopup="<?=$GLOBALS['fc_config']['hideSelfPopup']?>"
	showConfirmation="<?=$GLOBALS['fc_config']['showConfirmation']?>"
	labelFormat="<?=$GLOBALS['fc_config']['labelFormat']?>"
	maxMessageSize="<?=$GLOBALS['fc_config']['maxMessageSize']?>"
	maxMessageCount="<?=$GLOBALS['fc_config']['maxMessageCount']?>"
	userListAutoExpand="<?=$GLOBALS['fc_config']['userListAutoExpand']?>"
	helpUrl="<?=$GLOBALS['fc_config']['helpUrl']?>" 
	msgRequestInterval="<?=$GLOBALS['fc_config']['msgRequestInterval']?>" 
	msgRequestIntervalAway="<?=$GLOBALS['fc_config']['msgRequestIntervalAway']?>" 
	floodInterval="<?=$GLOBALS['fc_config']['floodInterval']?>" 
	inactivityInterval="<?=$GLOBALS['fc_config']['inactivityInterval']?>" 
	roomTitleFormat="<?=$GLOBALS['fc_config']['roomTitleFormat']?>"
	maxUsersPerRoom="<?=$GLOBALS['fc_config']['maxUsersPerRoom']?>"
	listOrder="<?=$GLOBALS['fc_config']['listOrder']?>"
	disabledIRC="<?=$GLOBALS['fc_config']['disabledIRC']?>"
	defaultRoom="<?=$GLOBALS['fc_config']['defaultRoom']?>" 
	defaultTheme="<?=$GLOBALS['fc_config']['defaultTheme']?>" 
	defaultSkin="<?=$GLOBALS['fc_config']['defaultSkin']?>"
	defaultLanguage="<?=$GLOBALS['fc_config']['defaultLanguage']?>"
	allowLanguage="<?=$GLOBALS['fc_config']['allowLanguage']?>"
	splashWindow="<?=$GLOBALS['fc_config']['splashWindow']?>">

	<?php 	
		foreach($GLOBALS['fc_config']['layouts'] as $k => $v) {
			if(!$hasProfile) $v['allowProfile'] = false;
	?>
		<layout role="<?=$k?>" <?=array2attrs($v)?>>
		<toolbar <?=array2attrs($v['toolbar'])?>/>
		<optionPanel <?=array2attrs($v['optionPanel'])?>/>
		<?php foreach($v['constraints'] as $ck => $cv) {?>
			<constraint id="<?=$ck?>" <?=array2attrs($cv)?>/>
		<?php } ?>
		</layout>
	<?php } ?>
	<smiles <?=array2attrs($GLOBALS['fc_config']['smiles'])?>/>
	
	<avatars>
		<mod_only list="<?=$GLOBALS['fc_config']['avatars']['mod_only']?>"/>
		<user>
			<male>
				<mainchat <?=array2attrs($GLOBALS['fc_config']['avatars']['user']['male']['mainchat'])?>/>
				<room <?=array2attrs($GLOBALS['fc_config']['avatars']['user']['male']['room'])?>/>
			</male>
			<female>
				<mainchat <?=array2attrs($GLOBALS['fc_config']['avatars']['user']['female']['mainchat'])?>/>
				<room <?=array2attrs($GLOBALS['fc_config']['avatars']['user']['female']['room'])?>/>
			</female>
		</user>
		<admin>
			<male>
				<mainchat <?=array2attrs($GLOBALS['fc_config']['avatars']['admin']['male']['mainchat'])?>/>
				<room <?=array2attrs($GLOBALS['fc_config']['avatars']['admin']['male']['room'])?>/>
			</male>
			<female>
				<mainchat <?=array2attrs($GLOBALS['fc_config']['avatars']['admin']['female']['mainchat'])?>/>
				<room <?=array2attrs($GLOBALS['fc_config']['avatars']['admin']['female']['room'])?>/>
			</female>
		</admin>
	</avatars>
	
	<sound <?=array2attrs($GLOBALS['fc_config']['sound'])?>/>
	<sound_options <?=array2attrs($GLOBALS['fc_config']['sound_options'])?>/>
	
	<text>
		<itemToChange myTextColor="<?=$GLOBALS['fc_config']['text']['itemToChange']['myTextColor']?>"> 
			<mainChat <?=array2attrs($GLOBALS['fc_config']['text']['itemToChange']['mainChat'])?>/>
			<interfaceElements <?=array2attrs($GLOBALS['fc_config']['text']['itemToChange']['interfaceElements'])?>/>
			<title <?=array2attrs($GLOBALS['fc_config']['text']['itemToChange']['title'])?>/>
		</itemToChange>
		<fontSize <?=array2attrs($GLOBALS['fc_config']['text']['fontSize'])?>/>
		<fontFamily <?=array2attrs($GLOBALS['fc_config']['text']['fontFamily'])?>/>
	</text>
	
	<special_language <?=array2attrs($GLOBALS['fc_config']['special_language'])?>/>
	
	<?php foreach($GLOBALS['fc_config']['skin'] as $k => $v) {?>
		<skin id="<?=$k?>" <?=array2attrs($v)?>/>
	<?php } ?>
	
	<?php foreach($GLOBALS['fc_config']['themes'] as $k => $v) {?>
		<theme id="<?=$k?>" <?=array2attrs($v)?>/>
	<?php } ?>
	<?php foreach($GLOBALS['fc_config']['languages'] as $k => $v) {?>
		<language id="<?=$k?>" name="<?=$v['name']?>">
			<messages 
				login="<?=$v['messages']['login']?>" 
				wrongPass="<?=$v['messages']['wrongPass']?>" 
				anotherlogin="<?=$v['messages']['anotherlogin']?>" 
				banned="<?=$v['messages']['banned']?>" 
				expiredlogin="<?=$v['messages']['expiredlogin']?>"
			/>
			<dialog id="login" <?=array2attrs($v['dialog']['login'])?>/>
		</language>
	<?php }?>
	
	<logout <?=array2attrs($GLOBALS['fc_config']['logout'])?>/>
	
	<module <?=array2attrs($GLOBALS['fc_config']['module'])?>/>
	
</settings>