#initclip 10

_global.EffectsTab = function() {
	super();
	
	this.isCanceled = false;
	this._visible = false;
	
	this.effectsTarget = null;
	this.settings = null;
	this.language = null;
	
	this.selectedEffectsProperties = new Object();
	this.selectedEffectsProperties.mainchat = new Object();
	this.selectedEffectsProperties.room = new Object();
	
	this.selectedSkin = new Object();
};

_global.EffectsTab.prototype = new Object();

//PUBLIC METHODS.

_global.EffectsTab.prototype.setEnabled = function(inDialogEnabled) {
	
	for(var itm in this)
	{ 
		if( this[itm]._name != undefined )
			if(this[itm]._name.indexOf("combo") == 0)
				this[itm].setEnabled(inDialogEnabled);
			if( this[itm]._name.indexOf("btn") == 0)
			     this[itm].enabled = (inDialogEnabled);
			if( this[itm]._name.indexOf("cb")  == 0)
			     this[itm].setEnabled(inDialogEnabled);
			if( this[itm]._name.indexOf("sb")  == 0)
			     this[itm].setEnabled(inDialogEnabled);     
	}
};

_global.EffectsTab.prototype.show = function(init) {
	
	if ( not init )
	{ 
		this.cbMainchat.setChangeHandler('processMainchat', this);
		this.cbRoomlist.setChangeHandler('processRoomlist', this);
		this._visible = true;
		return;
	}
		
	this.isCanceled = false;
	
	if(this.settings.layout.toolbar.smilies == false)
	{ 
		this.cbMainchat.setEnabled(false);
		this.cbRoomlist.setEnabled(false);
		this.comboMainchat.setEnabled(false);
		this.comboRoomlist.setEnabled(false);
	}
	else
		for(var itm in this)
		{ 
			if( this[itm]._name != undefined )
				if(this[itm]._name.indexOf("combo") == 0 )
				{ 	
					this[itm].setItemSymbol('SmileDropDownCustomItem');
					this[itm].setItemSymbolOnTop(true);
					var parent = this._parent.parent;
					parent.fillSmieDropdown(parent.settings.smiles, this[itm], false);
				}
		}
	
	
	this.selectedSkin = this.settings.user.skin;
	if(this._parent.tabs[0] != undefined)
	{
		this.selectedSkin = this._parent.tabs[0].getSelectedSkin();
		this.selectedSkin.showBackgroundImages = this.settings.user.skin.showBackgroundImages;
		this.selectedSkin.uiAlpha = this.settings.user.skin.uiAlpha;
	}
	
	this.setTransparency(this.selectedSkin);
	
	this.cbShowBackgroundImages.setChangeHandler('processCustomAlpha', this);
	this.cbSplashWindow.setValue(this.settings.splashWindow);
	this.cbSplashWindow.setChangeHandler('processSplashWindow', this);
	
	this.sbUiAlpha.setChangeHandler('processCustomAlpha', this);
	this.btnCustom.setClickHandler('processCustom', this);
	
	this.cbMainchat.setValue(this.settings.user.avatars.mainchat.default_state);
	this.cbRoomlist.setValue(this.settings.user.avatars.room.default_state);
	
	this.cbMainchat.setChangeHandler('processMainchat', this);
	this.cbRoomlist.setChangeHandler('processRoomlist', this);
	
	var mainchatInd = 0, roomlistInd = 0;
	var len = Math.max(this.comboMainchat.getLength(), this.comboRoomlist.getLength());
	for(var i = 0; i<len; i++)
	{
		var mc_data = this.comboMainchat.getItemAt(i).data;
		
		if(mc_data.patternIcon == this.settings.user.avatars.mainchat.default_value)
			mainchatInd = i;
		
		var rl_data = this.comboRoomlist.getItemAt(i).data; 	
		if(rl_data.patternIcon == this.settings.user.avatars.room.default_value)
			roomlistInd = i;	
	}
	
	this.comboMainchat.setSelectedIndex(mainchatInd);
	this.comboRoomlist.setSelectedIndex(roomlistInd);
	
	if(this.settings.user.avatars.mainchat.allow_override != true)
		this.comboMainchat.setEnabled(false);
	if(this.settings.user.avatars.room.allow_override != true)
		this.comboRoomlist.setEnabled(false);
	
	this.comboMainchat.setChangeHandler('processMainchat', this);
	this.comboRoomlist.setChangeHandler('processRoomlist', this);	
	//--------------------------------------------------------------------------------//
	this.readSelectedEffectsProperties();
	
	this._visible = true;
};

_global.EffectsTab.prototype.hide = function() {
	this.cbMainchat.setChangeHandler(null);
	this.cbRoomlist.setChangeHandler(null);
	this._visible = false;
}

_global.EffectsTab.prototype.canceled = function() {
	return this.isCanceled;
};

_global.EffectsTab.prototype.setTransparency = function(inSkin) {
	if ((inSkin.backgroundImage == null) || (inSkin.backgroundImage == '')) {
		this.cbShowBackgroundImages.setEnabled(true);
		this.sbUiAlpha.setEnabled(true);
		this.cbShowBackgroundImages.setValue(false);
		this.sbUiAlpha.setValue(100);
		this.cbShowBackgroundImages.setEnabled(false);
		this.sbUiAlpha.setEnabled(false);
	} else {
		this.cbShowBackgroundImages.setEnabled(true);
		this.sbUiAlpha.setEnabled(true);
		this.cbShowBackgroundImages.setValue(inSkin.showBackgroundImages);
		this.sbUiAlpha.setValue(inSkin.uiAlpha);
	}
};

_global.EffectsTab.prototype.setSettings = function(inSettings) {
	this.settings = inSettings;
};

_global.EffectsTab.prototype.setEffectsTarget = function(inEffectsTarget) {
	this.effectsTarget = inEffectsTarget;
};

_global.EffectsTab.prototype.getSelectedSkin = function() {
	return this.selectedSkin;
};

_global.EffectsTab.prototype.getSelectedEffectsProperties = function() {
	return this.selectedEffectsProperties;
};

_global.EffectsTab.prototype.applyTextProperty = function(propName, val)
{
	for(var itm in this)
	{ 
		if( this[itm]._name != undefined )
			if ( this[itm]._name.indexOf("label") == 0 ) 
			{ 
				var setVal = val;
				if(this[itm]._name == 'labelAvatars' || this[itm]._name == 'labelBackground')
				{
					if(propName == 'size') setVal = 20;
				}
				
				setTextProperty(propName, setVal, this[itm], true);
			}
	}
	
	var max_width = Math.max(this.labelMainchat.textWidth, this.labelRoomlist.textWidth);
	var new_x = this.labelMainchat._x + max_width + 10;
	var dim   = this._parent.getSize();
	if((new_x + this.comboMainchat._width) < (dim.width - 10))
		this.comboMainchat._x = this.comboRoomlist._x = new_x;
	else 
		this.comboMainchat._x = this.comboRoomlist._x = dim.width - this.comboMainchat._width - 20;
		
	var all_back_width = this.cbShowBackgroundImages._width + 10 + this.labelUiAlpha.textWidth + 10 + this.labelMinus._width + this.sbUiAlpha._width + this.labelPlus._width; 
	var new_x2 = ((dim.width - 10) - all_back_width + this.comboMainchat._x + this.comboMainchat._width) / 2;
	this.labelBackground._x = this.cbShowBackgroundImages._x = this.cbSplashWindow._x = new_x2;
	var new_x3 = new_x2 + this.cbShowBackgroundImages._width + 10;
	this.labelShowBackgroundImages._x = this.labelUiAlpha._x = this.btnCustom._x = this.labelSplashWindow._x = new_x3;
	
	this.labelMinus._x =	this.labelUiAlpha._x + this.labelUiAlpha.textWidth + 10;
	this.sbUiAlpha._x  = this.labelMinus._x + this.labelMinus._width;
	this.labelPlus._x  = this.sbUiAlpha._x + this.sbUiAlpha._width;
};

_global.EffectsTab.prototype.applyStyle = function(inStyle) {
	this.cbShowBackgroundImages.setStyleProperty('background', 0xffffff);
	this.cbShowBackgroundImages.setStyleProperty('face', 0x000000);
	
	this.cbSplashWindow.setStyleProperty('background', 0xffffff);
	this.cbSplashWindow.setStyleProperty('face', 0x000000);
	
	for(var itm in this)
	{ 
		if( this[itm]._name != undefined )
			if ( this[itm]._name.indexOf("label") == 0 )
				this[itm].textColor = inStyle.bodyText;      
	}
};

_global.EffectsTab.prototype.applyLanguage = function(inLanguage) {
	this.language = inLanguage;
	
	if(this.language.dialog.effects != undefined)
	{ 
		this.labelShowBackgroundImages.text = this.language.dialog.effects.showBackgroundImages;
		this.labelSplashWindow.text = this.language.dialog.effects.splashWindow;
		this.labelUiAlpha.text = this.language.dialog.effects.uiAlpha;
		this.labelAvatars.text    = this.language.dialog.effects.avatars;
		this.labelMainchat.text   = this.language.dialog.effects.mainchat;
		this.labelRoomlist.text   = this.language.dialog.effects.roomlist;
		this.labelBackground.text = this.language.dialog.effects.background;
		this.btnCustom.setLabel(this.language.dialog.effects.custom);
	}
};

_global.EffectsTab.prototype.readSelectedEffectsProperties = function() {
	this.selectedSkin.showBackgroundImages = this.cbShowBackgroundImages.getValue();
	this.selectedSkin.uiAlpha = this.sbUiAlpha.getValue();
	
	this.selectedEffectsProperties.splashWindow =  this.cbSplashWindow.getValue();
	
	this.selectedEffectsProperties.role   = this.settings.user.avatars.role;
	this.selectedEffectsProperties.gender = this.settings.user.avatars.gender;
	
	this.selectedEffectsProperties.mainchat.allow_override = this.settings.user.avatars.mainchat.allow_override;
	this.selectedEffectsProperties.room.allow_override = this.settings.user.avatars.room.allow_override;
	
	this.selectedEffectsProperties.mainchat.default_state = (this.cbMainchat.getEnabled())? this.cbMainchat.getValue() : false;
	this.selectedEffectsProperties.room.default_state = (this.cbRoomlist.getEnabled())? this.cbRoomlist.getValue() : false;
	
	var mc_data = (this.comboMainchat.getEnabled())? this.comboMainchat.getSelectedItem().data.patternIcon : this.settings.user.avatars.mainchat.default_value;
	this.selectedEffectsProperties.mainchat.default_value = mc_data;
	var rl_data = (this.comboRoomlist.getEnabled())? this.comboRoomlist.getSelectedItem().data.patternIcon : this.settings.user.avatars.room.default_value;
	this.selectedEffectsProperties.room.default_value = rl_data;
};

_global.EffectsTab.prototype.processOKButton = function() {
	this._visible = false;
};

_global.EffectsTab.prototype.processCancelButton = function() {
	this.selectedSkin = this.settings.user.skin;
	this.effectsTarget.applyBackground(this.selectedSkin);
	
	if(this.settings.user.avatars.mainchat.default_value != this.selectedEffectsProperties.mainchat.default_value || 
	   this.settings.user.avatars.mainchat.default_state != this.selectedEffectsProperties.mainchat.default_state)
	{ 
		this._parent.parent.setMainchatAvatar(this.settings.user.avatars.mainchat.default_value, this.settings.user.avatars.mainchat.default_state); 
	}
	if(this.settings.user.avatars.room.default_value != this.selectedEffectsProperties.room.default_value ||
	   this.settings.user.avatars.room.default_state != this.selectedEffectsProperties.room.default_state)
	{ 
		this._parent.parent.setRoomlistAvatar(this.settings.user.avatars.room.default_value, this.settings.user.avatars.room.default_state);
	}
	
	this._visible = false;
	this.isCanceled = true;
};

_global.EffectsTab.prototype.processSplashWindow = function(inControl) {
	this.selectedEffectsProperties.splashWindow =  this.cbSplashWindow.getValue();
};

_global.EffectsTab.prototype.processCustomAlpha = function(inControl) {
	if (!this.cbShowBackgroundImages.getValue() && this.sbUiAlpha.getEnabled()) {
		this.sbUiAlpha.setEnabled(false);
	}
	if (this.cbShowBackgroundImages.getValue() && !this.sbUiAlpha.getEnabled()) {
		this.sbUiAlpha.setEnabled(true);
	}
	
	this.readSelectedEffectsProperties();
	this.effectsTarget.applyBackground(this.selectedSkin);
};

_global.EffectsTab.prototype.processCustom = function(inControl) {
	var parent = this._parent.parent;
	var the_url = _root._url.substr(0, _root._url.lastIndexOf('/')) + '/';
	var lang =  parent.selectedLanguage['id'];
	if(this._parent.textTab != null) lang = this._parent.textTab.comboLanguage.getSelectedItem().data.id;
	var arg = 'userid=' + parent.selfUserId + '&lang=' + lang;
	
	getURL("javascript:openWindow('"+the_url+"load_avatar_bg.php?"+arg+"', 'loadAvartarBGWindow', '',490,230)");
};

_global.EffectsTab.prototype.processMainchat = function(inControl){ 
	this.readSelectedEffectsProperties();
	
	this._parent.parent.setMainchatAvatar(this.selectedEffectsProperties.mainchat.default_value, this.selectedEffectsProperties.mainchat.default_state); 
};

_global.EffectsTab.prototype.processRoomlist = function(inControl){ 
	this.readSelectedEffectsProperties();
	
	this._parent.parent.setRoomlistAvatar(this.selectedEffectsProperties.room.default_value, this.selectedEffectsProperties.room.default_state);
};

Object.registerClass('EffectsTab', _global.EffectsTab);

#endinitclip
